require '_h2ph_pre.ph';

unless(defined(&__ASM_MSR_H)) {
    eval 'sub __ASM_MSR_H () {1;}' unless defined(&__ASM_MSR_H);
    eval 'sub rdmsr {
        local($msr,$val1,$val2) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdmsr\\" : \\"=a\\" ($val1), \\"=d\\" ($val2) : \\"c\\" ($msr)));
    }' unless defined(&rdmsr);
    eval 'sub wrmsr {
        local($msr,$val1,$val2) = @_;
	    eval q( &__asm__  &__volatile__(\\"wrmsr\\" : : \\"c\\" ($msr), \\"a\\" ($val1), \\"d\\" ($val2)));
    }' unless defined(&wrmsr);
    eval 'sub rdtsc {
        local($low,$high) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdtsc\\" : \\"=a\\" ($low), \\"=d\\" ($high)));
    }' unless defined(&rdtsc);
    eval 'sub rdtscl {
        local($low) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdtsc\\" : \\"=a\\" ($low) : : \\"edx\\"));
    }' unless defined(&rdtscl);
    eval 'sub rdtscll {
        local($val) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdtsc\\" : \\"=A\\" ($val)));
    }' unless defined(&rdtscll);
    eval 'sub write_tsc {
        local($val1,$val2) = @_;
	    eval q( &wrmsr(0x10, $val1, $val2));
    }' unless defined(&write_tsc);
    eval 'sub rdpmc {
        local($counter,$low,$high) = @_;
	    eval q( &__asm__  &__volatile__(\\"rdpmc\\" : \\"=a\\" ($low), \\"=d\\" ($high) : \\"c\\" ($counter)));
    }' unless defined(&rdpmc);
    eval 'sub MSR_IA32_PLATFORM_ID () {0x017;}' unless defined(&MSR_IA32_PLATFORM_ID);
    eval 'sub MSR_IA32_APICBASE () {0x01b;}' unless defined(&MSR_IA32_APICBASE);
    eval 'sub MSR_IA32_APICBASE_BSP () {(1<<8);}' unless defined(&MSR_IA32_APICBASE_BSP);
    eval 'sub MSR_IA32_APICBASE_ENABLE () {(1<<11);}' unless defined(&MSR_IA32_APICBASE_ENABLE);
    eval 'sub MSR_IA32_APICBASE_BASE () {(0xfffff<<12);}' unless defined(&MSR_IA32_APICBASE_BASE);
    eval 'sub MSR_IA32_UCODE_WRITE () {0x079;}' unless defined(&MSR_IA32_UCODE_WRITE);
    eval 'sub MSR_IA32_UCODE_REV () {0x08b;}' unless defined(&MSR_IA32_UCODE_REV);
    eval 'sub MSR_IA32_PERFCTR0 () {0x0c1;}' unless defined(&MSR_IA32_PERFCTR0);
    eval 'sub MSR_IA32_PERFCTR1 () {0x0c2;}' unless defined(&MSR_IA32_PERFCTR1);
    eval 'sub MSR_IA32_MCG_CAP () {0x179;}' unless defined(&MSR_IA32_MCG_CAP);
    eval 'sub MSR_IA32_MCG_STATUS () {0x17a;}' unless defined(&MSR_IA32_MCG_STATUS);
    eval 'sub MSR_IA32_MCG_CTL () {0x17b;}' unless defined(&MSR_IA32_MCG_CTL);
    eval 'sub MSR_IA32_EVNTSEL0 () {0x186;}' unless defined(&MSR_IA32_EVNTSEL0);
    eval 'sub MSR_IA32_EVNTSEL1 () {0x187;}' unless defined(&MSR_IA32_EVNTSEL1);
    eval 'sub MSR_IA32_DEBUGCTLMSR () {0x1d9;}' unless defined(&MSR_IA32_DEBUGCTLMSR);
    eval 'sub MSR_IA32_LASTBRANCHFROMIP () {0x1db;}' unless defined(&MSR_IA32_LASTBRANCHFROMIP);
    eval 'sub MSR_IA32_LASTBRANCHTOIP () {0x1dc;}' unless defined(&MSR_IA32_LASTBRANCHTOIP);
    eval 'sub MSR_IA32_LASTINTFROMIP () {0x1dd;}' unless defined(&MSR_IA32_LASTINTFROMIP);
    eval 'sub MSR_IA32_LASTINTTOIP () {0x1de;}' unless defined(&MSR_IA32_LASTINTTOIP);
    eval 'sub MSR_IA32_MC0_BASE () {0x400;}' unless defined(&MSR_IA32_MC0_BASE);
    eval 'sub MSR_IA32_MC0_CTL_OFFSET () {0x0;}' unless defined(&MSR_IA32_MC0_CTL_OFFSET);
    eval 'sub MSR_IA32_MC0_STATUS_OFFSET () {0x1;}' unless defined(&MSR_IA32_MC0_STATUS_OFFSET);
    eval 'sub MSR_IA32_MC0_ADDR_OFFSET () {0x2;}' unless defined(&MSR_IA32_MC0_ADDR_OFFSET);
    eval 'sub MSR_IA32_MC0_MISC_OFFSET () {0x3;}' unless defined(&MSR_IA32_MC0_MISC_OFFSET);
    eval 'sub MSR_IA32_MC0_BANK_COUNT () {0x4;}' unless defined(&MSR_IA32_MC0_BANK_COUNT);
    eval 'sub MSR_K7_EVNTSEL0 () {0xc0010000;}' unless defined(&MSR_K7_EVNTSEL0);
    eval 'sub MSR_K7_PERFCTR0 () {0xc0010004;}' unless defined(&MSR_K7_PERFCTR0);
}
1;
